
use_bpm 62
use_random_seed 62
use_debug false

# some base chords in a ring
base_chords = [(chord :C, :minor), (chord :F, :major), (chord :Ab, :major), (chord :F, :minor)].ring

with_fx :reverb, mix: 0.8, room: 0.8 do
  live_loop :bassline do
    use_synth :dark_ambience
    # low stuff
    play base_chords.choose, amp: 1.3, attack: 0.6, release: 1.4, pitch: -12, sustain: 14
    
    # layer an octave higher
    with_fx :slicer, amp_min: 0.75, amp_max: 0.8, phase: 0.5, smooth: 0.25, reps: 8 do
      play base_chords.choose, amp: 0.7, attack: 1, release: 2, pitch: -0, sustain: 10
    end
    sleep 16
  end
end

with_fx :nrlpf, cutoff: 70, res: 0.2 do
  with_fx :slicer, amp_min: 0.9, amp_max: 1, phase: 0.5, smooth: 0.25 do
    live_loop :bwah do
      use_synth :hoover
      play base_chords.choose[0], amp: 0.4, attack: 3, decay: 0, sustain: 10, release: 3, pitch: -24
      sleep 16
    end
  end
end

with_fx :slicer, amp_min: 0.5, amp_max: 0.6, phase: 0.5, smooth: 0.25 do
  with_fx :ring_mod, mix: 0.2, pre_amp: 0.2 do
    with_fx :gverb, mix: 0.8, spread: 0.4, tail: 0.7, damp: 0.4, room: 200, pre_amp: 0.2 do
      with_fx :echo, decay: 1.25, phase: 0.125, mix: 0.6 do
        live_loop :melody do
          if rrand(0,1) > 0.3
            use_synth :pretty_bell
            play_pattern_timed base_chords.choose.reverse, 1, pitch: 12
          end
          sleep 8
        end
      end
    end
  end
end